<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TestRFC5861Compliance xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../testapidocs/org/apache/http/impl/client/cache/TestRFC5861Compliance.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  <strong class="jxr_keyword">package</strong> org.apache.http.impl.client.cache;
<a class="jxr_linenumber" name="28" href="#28">28</a>  
<a class="jxr_linenumber" name="29" href="#29">29</a>  <strong class="jxr_keyword">import</strong> <strong class="jxr_keyword">static</strong> org.junit.Assert.*;
<a class="jxr_linenumber" name="30" href="#30">30</a>  
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.io.ByteArrayInputStream;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.util.Date;
<a class="jxr_linenumber" name="33" href="#33">33</a>  
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> org.apache.http.Header;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpEntity;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpRequest;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpResponse;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpStatus;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpVersion;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.entity.InputStreamEntity;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.cookie.DateUtils;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.http.message.BasicHttpRequest;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.junit.Test;
<a class="jxr_linenumber" name="44" href="#44">44</a>  
<a class="jxr_linenumber" name="45" href="#45">45</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="46" href="#46">46</a>  <em class="jxr_javadoccomment"> * A suite of acceptance tests for compliance with RFC5861, which</em>
<a class="jxr_linenumber" name="47" href="#47">47</a>  <em class="jxr_javadoccomment"> * describes the stale-if-error and stale-while-revalidate</em>
<a class="jxr_linenumber" name="48" href="#48">48</a>  <em class="jxr_javadoccomment"> * Cache-Control extensions.</em>
<a class="jxr_linenumber" name="49" href="#49">49</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="50" href="#50">50</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/apache/http/impl/client/cache/TestRFC5861Compliance.html">TestRFC5861Compliance</a> <strong class="jxr_keyword">extends</strong> <a href="../../../../../../org/apache/http/impl/client/cache/AbstractProtocolTest.html">AbstractProtocolTest</a> {
<a class="jxr_linenumber" name="51" href="#51">51</a>  
<a class="jxr_linenumber" name="52" href="#52">52</a>      <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="53" href="#53">53</a>  <em class="jxr_comment">     * "The stale-if-error Cache-Control extension indicates that when an</em>
<a class="jxr_linenumber" name="54" href="#54">54</a>  <em class="jxr_comment">     * error is encountered, a cached stale response MAY be used to satisfy</em>
<a class="jxr_linenumber" name="55" href="#55">55</a>  <em class="jxr_comment">     * the request, regardless of other freshness information.When used as a</em>
<a class="jxr_linenumber" name="56" href="#56">56</a>  <em class="jxr_comment">     * request Cache-Control extension, its scope of application is the request</em>
<a class="jxr_linenumber" name="57" href="#57">57</a>  <em class="jxr_comment">     * it appears in; when used as a response Cache-Control extension, its</em>
<a class="jxr_linenumber" name="58" href="#58">58</a>  <em class="jxr_comment">     * scope is any request applicable to the cached response in which it</em>
<a class="jxr_linenumber" name="59" href="#59">59</a>  <em class="jxr_comment">     * occurs.Its value indicates the upper limit to staleness; when the cached</em>
<a class="jxr_linenumber" name="60" href="#60">60</a>  <em class="jxr_comment">     * response is more stale than the indicated amount, the cached response</em>
<a class="jxr_linenumber" name="61" href="#61">61</a>  <em class="jxr_comment">     * SHOULD NOT be used to satisfy the request, absent other information.</em>
<a class="jxr_linenumber" name="62" href="#62">62</a>  <em class="jxr_comment">     * In this context, an error is any situation that would result in a</em>
<a class="jxr_linenumber" name="63" href="#63">63</a>  <em class="jxr_comment">     * 500, 502, 503, or 504 HTTP response status code being returned."</em>
<a class="jxr_linenumber" name="64" href="#64">64</a>  <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="65" href="#65">65</a>  <em class="jxr_comment">     * <a href="http://tools.ietf.org/html/rfc5861" target="alexandria_uri">http://tools.ietf.org/html/rfc5861</a></em>
<a class="jxr_linenumber" name="66" href="#66">66</a>  <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>      @Test
<a class="jxr_linenumber" name="68" href="#68">68</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleIfErrorInResponseIsTrueReturnsStaleEntryWithWarning()
<a class="jxr_linenumber" name="69" href="#69">69</a>              <strong class="jxr_keyword">throws</strong> Exception{
<a class="jxr_linenumber" name="70" href="#70">70</a>          Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(<strong class="jxr_keyword">new</strong> Date().getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="71" href="#71">71</a>          HttpRequest req1 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="72" href="#72">72</a>          HttpResponse resp1 = HttpTestUtils.make200Response(tenSecondsAgo,
<a class="jxr_linenumber" name="73" href="#73">73</a>                  <span class="jxr_string">"public, max-age=5, stale-if-error=60"</span>);
<a class="jxr_linenumber" name="74" href="#74">74</a>  
<a class="jxr_linenumber" name="75" href="#75">75</a>          backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="76" href="#76">76</a>  
<a class="jxr_linenumber" name="77" href="#77">77</a>          HttpRequest req2 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="78" href="#78">78</a>          HttpResponse resp2 = HttpTestUtils.make500Response();
<a class="jxr_linenumber" name="79" href="#79">79</a>  
<a class="jxr_linenumber" name="80" href="#80">80</a>          backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="81" href="#81">81</a>  
<a class="jxr_linenumber" name="82" href="#82">82</a>          replayMocks();
<a class="jxr_linenumber" name="83" href="#83">83</a>          impl.execute(host,req1);
<a class="jxr_linenumber" name="84" href="#84">84</a>          HttpResponse result = impl.execute(host,req2);
<a class="jxr_linenumber" name="85" href="#85">85</a>          verifyMocks();
<a class="jxr_linenumber" name="86" href="#86">86</a>  
<a class="jxr_linenumber" name="87" href="#87">87</a>          HttpTestUtils.assert110WarningFound(result);
<a class="jxr_linenumber" name="88" href="#88">88</a>      }
<a class="jxr_linenumber" name="89" href="#89">89</a>  
<a class="jxr_linenumber" name="90" href="#90">90</a>      @Test
<a class="jxr_linenumber" name="91" href="#91">91</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testConsumesErrorResponseWhenServingStale()
<a class="jxr_linenumber" name="92" href="#92">92</a>              <strong class="jxr_keyword">throws</strong> Exception{
<a class="jxr_linenumber" name="93" href="#93">93</a>          Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(<strong class="jxr_keyword">new</strong> Date().getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="94" href="#94">94</a>          HttpRequest req1 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="95" href="#95">95</a>          HttpResponse resp1 = HttpTestUtils.make200Response(tenSecondsAgo,
<a class="jxr_linenumber" name="96" href="#96">96</a>                  <span class="jxr_string">"public, max-age=5, stale-if-error=60"</span>);
<a class="jxr_linenumber" name="97" href="#97">97</a>  
<a class="jxr_linenumber" name="98" href="#98">98</a>          backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="99" href="#99">99</a>  
<a class="jxr_linenumber" name="100" href="#100">100</a>         HttpRequest req2 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="101" href="#101">101</a>         HttpResponse resp2 = HttpTestUtils.make500Response();
<a class="jxr_linenumber" name="102" href="#102">102</a>         byte[] body = HttpTestUtils.getRandomBytes(101);
<a class="jxr_linenumber" name="103" href="#103">103</a>         ByteArrayInputStream buf = <strong class="jxr_keyword">new</strong> ByteArrayInputStream(body);
<a class="jxr_linenumber" name="104" href="#104">104</a>         <a href="../../../../../../org/apache/http/impl/client/cache/ConsumableInputStream.html">ConsumableInputStream</a> cis = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/impl/client/cache/ConsumableInputStream.html">ConsumableInputStream</a>(buf);
<a class="jxr_linenumber" name="105" href="#105">105</a>         HttpEntity entity = <strong class="jxr_keyword">new</strong> InputStreamEntity(cis, 101);
<a class="jxr_linenumber" name="106" href="#106">106</a>         resp2.setEntity(entity);
<a class="jxr_linenumber" name="107" href="#107">107</a> 
<a class="jxr_linenumber" name="108" href="#108">108</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="109" href="#109">109</a> 
<a class="jxr_linenumber" name="110" href="#110">110</a>         replayMocks();
<a class="jxr_linenumber" name="111" href="#111">111</a>         impl.execute(host,req1);
<a class="jxr_linenumber" name="112" href="#112">112</a>         impl.execute(host,req2);
<a class="jxr_linenumber" name="113" href="#113">113</a>         verifyMocks();
<a class="jxr_linenumber" name="114" href="#114">114</a> 
<a class="jxr_linenumber" name="115" href="#115">115</a>         assertTrue(cis.wasClosed());
<a class="jxr_linenumber" name="116" href="#116">116</a>     }
<a class="jxr_linenumber" name="117" href="#117">117</a> 
<a class="jxr_linenumber" name="118" href="#118">118</a>     @Test
<a class="jxr_linenumber" name="119" href="#119">119</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleIfErrorInResponseYieldsToMustRevalidate()
<a class="jxr_linenumber" name="120" href="#120">120</a>             <strong class="jxr_keyword">throws</strong> Exception{
<a class="jxr_linenumber" name="121" href="#121">121</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(<strong class="jxr_keyword">new</strong> Date().getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="122" href="#122">122</a>         HttpRequest req1 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="123" href="#123">123</a>         HttpResponse resp1 = HttpTestUtils.make200Response(tenSecondsAgo,
<a class="jxr_linenumber" name="124" href="#124">124</a>                 <span class="jxr_string">"public, max-age=5, stale-if-error=60, must-revalidate"</span>);
<a class="jxr_linenumber" name="125" href="#125">125</a> 
<a class="jxr_linenumber" name="126" href="#126">126</a>         backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="127" href="#127">127</a> 
<a class="jxr_linenumber" name="128" href="#128">128</a>         HttpRequest req2 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="129" href="#129">129</a>         HttpResponse resp2 = HttpTestUtils.make500Response();
<a class="jxr_linenumber" name="130" href="#130">130</a> 
<a class="jxr_linenumber" name="131" href="#131">131</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="132" href="#132">132</a> 
<a class="jxr_linenumber" name="133" href="#133">133</a>         replayMocks();
<a class="jxr_linenumber" name="134" href="#134">134</a>         impl.execute(host,req1);
<a class="jxr_linenumber" name="135" href="#135">135</a>         HttpResponse result = impl.execute(host,req2);
<a class="jxr_linenumber" name="136" href="#136">136</a>         verifyMocks();
<a class="jxr_linenumber" name="137" href="#137">137</a> 
<a class="jxr_linenumber" name="138" href="#138">138</a>         assertTrue(HttpStatus.SC_OK != result.getStatusLine().getStatusCode());
<a class="jxr_linenumber" name="139" href="#139">139</a>     }
<a class="jxr_linenumber" name="140" href="#140">140</a> 
<a class="jxr_linenumber" name="141" href="#141">141</a>     @Test
<a class="jxr_linenumber" name="142" href="#142">142</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleIfErrorInResponseYieldsToProxyRevalidateForSharedCache()
<a class="jxr_linenumber" name="143" href="#143">143</a>             <strong class="jxr_keyword">throws</strong> Exception{
<a class="jxr_linenumber" name="144" href="#144">144</a>         assertTrue(impl.isSharedCache());
<a class="jxr_linenumber" name="145" href="#145">145</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(<strong class="jxr_keyword">new</strong> Date().getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="146" href="#146">146</a>         HttpRequest req1 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="147" href="#147">147</a>         HttpResponse resp1 = HttpTestUtils.make200Response(tenSecondsAgo,
<a class="jxr_linenumber" name="148" href="#148">148</a>                 <span class="jxr_string">"public, max-age=5, stale-if-error=60, proxy-revalidate"</span>);
<a class="jxr_linenumber" name="149" href="#149">149</a> 
<a class="jxr_linenumber" name="150" href="#150">150</a>         backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="151" href="#151">151</a> 
<a class="jxr_linenumber" name="152" href="#152">152</a>         HttpRequest req2 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="153" href="#153">153</a>         HttpResponse resp2 = HttpTestUtils.make500Response();
<a class="jxr_linenumber" name="154" href="#154">154</a> 
<a class="jxr_linenumber" name="155" href="#155">155</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="156" href="#156">156</a> 
<a class="jxr_linenumber" name="157" href="#157">157</a>         replayMocks();
<a class="jxr_linenumber" name="158" href="#158">158</a>         impl.execute(host,req1);
<a class="jxr_linenumber" name="159" href="#159">159</a>         HttpResponse result = impl.execute(host,req2);
<a class="jxr_linenumber" name="160" href="#160">160</a>         verifyMocks();
<a class="jxr_linenumber" name="161" href="#161">161</a> 
<a class="jxr_linenumber" name="162" href="#162">162</a>         assertTrue(HttpStatus.SC_OK != result.getStatusLine().getStatusCode());
<a class="jxr_linenumber" name="163" href="#163">163</a>     }
<a class="jxr_linenumber" name="164" href="#164">164</a> 
<a class="jxr_linenumber" name="165" href="#165">165</a>     @Test
<a class="jxr_linenumber" name="166" href="#166">166</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleIfErrorInResponseNeedNotYieldToProxyRevalidateForPrivateCache()
<a class="jxr_linenumber" name="167" href="#167">167</a>             <strong class="jxr_keyword">throws</strong> Exception{
<a class="jxr_linenumber" name="168" href="#168">168</a>         CacheConfig config = <strong class="jxr_keyword">new</strong> CacheConfig();
<a class="jxr_linenumber" name="169" href="#169">169</a>         config.setSharedCache(false);
<a class="jxr_linenumber" name="170" href="#170">170</a>         impl = <strong class="jxr_keyword">new</strong> CachingHttpClient(mockBackend, config);
<a class="jxr_linenumber" name="171" href="#171">171</a> 
<a class="jxr_linenumber" name="172" href="#172">172</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(<strong class="jxr_keyword">new</strong> Date().getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="173" href="#173">173</a>         HttpRequest req1 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="174" href="#174">174</a>         HttpResponse resp1 = HttpTestUtils.make200Response(tenSecondsAgo,
<a class="jxr_linenumber" name="175" href="#175">175</a>                 <span class="jxr_string">"public, max-age=5, stale-if-error=60, proxy-revalidate"</span>);
<a class="jxr_linenumber" name="176" href="#176">176</a> 
<a class="jxr_linenumber" name="177" href="#177">177</a>         backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="178" href="#178">178</a> 
<a class="jxr_linenumber" name="179" href="#179">179</a>         HttpRequest req2 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="180" href="#180">180</a>         HttpResponse resp2 = HttpTestUtils.make500Response();
<a class="jxr_linenumber" name="181" href="#181">181</a> 
<a class="jxr_linenumber" name="182" href="#182">182</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="183" href="#183">183</a> 
<a class="jxr_linenumber" name="184" href="#184">184</a>         replayMocks();
<a class="jxr_linenumber" name="185" href="#185">185</a>         impl.execute(host,req1);
<a class="jxr_linenumber" name="186" href="#186">186</a>         HttpResponse result = impl.execute(host,req2);
<a class="jxr_linenumber" name="187" href="#187">187</a>         verifyMocks();
<a class="jxr_linenumber" name="188" href="#188">188</a> 
<a class="jxr_linenumber" name="189" href="#189">189</a>         HttpTestUtils.assert110WarningFound(result);
<a class="jxr_linenumber" name="190" href="#190">190</a>     }
<a class="jxr_linenumber" name="191" href="#191">191</a> 
<a class="jxr_linenumber" name="192" href="#192">192</a>     @Test
<a class="jxr_linenumber" name="193" href="#193">193</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleIfErrorInResponseYieldsToExplicitFreshnessRequest()
<a class="jxr_linenumber" name="194" href="#194">194</a>             <strong class="jxr_keyword">throws</strong> Exception{
<a class="jxr_linenumber" name="195" href="#195">195</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(<strong class="jxr_keyword">new</strong> Date().getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="196" href="#196">196</a>         HttpRequest req1 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="197" href="#197">197</a>         HttpResponse resp1 = HttpTestUtils.make200Response(tenSecondsAgo,
<a class="jxr_linenumber" name="198" href="#198">198</a>                 <span class="jxr_string">"public, max-age=5, stale-if-error=60"</span>);
<a class="jxr_linenumber" name="199" href="#199">199</a> 
<a class="jxr_linenumber" name="200" href="#200">200</a>         backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="201" href="#201">201</a> 
<a class="jxr_linenumber" name="202" href="#202">202</a>         HttpRequest req2 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="203" href="#203">203</a>         req2.setHeader(<span class="jxr_string">"Cache-Control"</span>,<span class="jxr_string">"min-fresh=2"</span>);
<a class="jxr_linenumber" name="204" href="#204">204</a>         HttpResponse resp2 = HttpTestUtils.make500Response();
<a class="jxr_linenumber" name="205" href="#205">205</a> 
<a class="jxr_linenumber" name="206" href="#206">206</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="207" href="#207">207</a> 
<a class="jxr_linenumber" name="208" href="#208">208</a>         replayMocks();
<a class="jxr_linenumber" name="209" href="#209">209</a>         impl.execute(host,req1);
<a class="jxr_linenumber" name="210" href="#210">210</a>         HttpResponse result = impl.execute(host,req2);
<a class="jxr_linenumber" name="211" href="#211">211</a>         verifyMocks();
<a class="jxr_linenumber" name="212" href="#212">212</a> 
<a class="jxr_linenumber" name="213" href="#213">213</a>         assertTrue(HttpStatus.SC_OK != result.getStatusLine().getStatusCode());
<a class="jxr_linenumber" name="214" href="#214">214</a>     }
<a class="jxr_linenumber" name="215" href="#215">215</a> 
<a class="jxr_linenumber" name="216" href="#216">216</a>     @Test
<a class="jxr_linenumber" name="217" href="#217">217</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleIfErrorInRequestIsTrueReturnsStaleEntryWithWarning()
<a class="jxr_linenumber" name="218" href="#218">218</a>             <strong class="jxr_keyword">throws</strong> Exception{
<a class="jxr_linenumber" name="219" href="#219">219</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(<strong class="jxr_keyword">new</strong> Date().getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="220" href="#220">220</a>         HttpRequest req1 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="221" href="#221">221</a>         HttpResponse resp1 = HttpTestUtils.make200Response(tenSecondsAgo,
<a class="jxr_linenumber" name="222" href="#222">222</a>                 <span class="jxr_string">"public, max-age=5"</span>);
<a class="jxr_linenumber" name="223" href="#223">223</a> 
<a class="jxr_linenumber" name="224" href="#224">224</a>         backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="225" href="#225">225</a> 
<a class="jxr_linenumber" name="226" href="#226">226</a>         HttpRequest req2 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="227" href="#227">227</a>         req2.setHeader(<span class="jxr_string">"Cache-Control"</span>,<span class="jxr_string">"public, stale-if-error=60"</span>);
<a class="jxr_linenumber" name="228" href="#228">228</a>         HttpResponse resp2 = HttpTestUtils.make500Response();
<a class="jxr_linenumber" name="229" href="#229">229</a> 
<a class="jxr_linenumber" name="230" href="#230">230</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="231" href="#231">231</a> 
<a class="jxr_linenumber" name="232" href="#232">232</a>         replayMocks();
<a class="jxr_linenumber" name="233" href="#233">233</a>         impl.execute(host,req1);
<a class="jxr_linenumber" name="234" href="#234">234</a>         HttpResponse result = impl.execute(host,req2);
<a class="jxr_linenumber" name="235" href="#235">235</a>         verifyMocks();
<a class="jxr_linenumber" name="236" href="#236">236</a> 
<a class="jxr_linenumber" name="237" href="#237">237</a>         HttpTestUtils.assert110WarningFound(result);
<a class="jxr_linenumber" name="238" href="#238">238</a>     }
<a class="jxr_linenumber" name="239" href="#239">239</a> 
<a class="jxr_linenumber" name="240" href="#240">240</a>     @Test
<a class="jxr_linenumber" name="241" href="#241">241</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleIfErrorInResponseIsFalseReturnsError()
<a class="jxr_linenumber" name="242" href="#242">242</a>             <strong class="jxr_keyword">throws</strong> Exception{
<a class="jxr_linenumber" name="243" href="#243">243</a>         Date now = <strong class="jxr_keyword">new</strong> Date();
<a class="jxr_linenumber" name="244" href="#244">244</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(now.getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="245" href="#245">245</a>         HttpRequest req1 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="246" href="#246">246</a>         HttpResponse resp1 = HttpTestUtils.make200Response(tenSecondsAgo,
<a class="jxr_linenumber" name="247" href="#247">247</a>                 <span class="jxr_string">"public, max-age=5, stale-if-error=2"</span>);
<a class="jxr_linenumber" name="248" href="#248">248</a> 
<a class="jxr_linenumber" name="249" href="#249">249</a>         backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="250" href="#250">250</a> 
<a class="jxr_linenumber" name="251" href="#251">251</a>         HttpRequest req2 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="252" href="#252">252</a>         HttpResponse resp2 = HttpTestUtils.make500Response();
<a class="jxr_linenumber" name="253" href="#253">253</a> 
<a class="jxr_linenumber" name="254" href="#254">254</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="255" href="#255">255</a> 
<a class="jxr_linenumber" name="256" href="#256">256</a>         replayMocks();
<a class="jxr_linenumber" name="257" href="#257">257</a>         impl.execute(host,req1);
<a class="jxr_linenumber" name="258" href="#258">258</a>         HttpResponse result = impl.execute(host,req2);
<a class="jxr_linenumber" name="259" href="#259">259</a>         verifyMocks();
<a class="jxr_linenumber" name="260" href="#260">260</a> 
<a class="jxr_linenumber" name="261" href="#261">261</a>         assertEquals(HttpStatus.SC_INTERNAL_SERVER_ERROR,
<a class="jxr_linenumber" name="262" href="#262">262</a>                 result.getStatusLine().getStatusCode());
<a class="jxr_linenumber" name="263" href="#263">263</a>     }
<a class="jxr_linenumber" name="264" href="#264">264</a> 
<a class="jxr_linenumber" name="265" href="#265">265</a>     @Test
<a class="jxr_linenumber" name="266" href="#266">266</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleIfErrorInRequestIsFalseReturnsError()
<a class="jxr_linenumber" name="267" href="#267">267</a>             <strong class="jxr_keyword">throws</strong> Exception{
<a class="jxr_linenumber" name="268" href="#268">268</a>         Date now = <strong class="jxr_keyword">new</strong> Date();
<a class="jxr_linenumber" name="269" href="#269">269</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(now.getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="270" href="#270">270</a>         HttpRequest req1 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="271" href="#271">271</a>         HttpResponse resp1 = HttpTestUtils.make200Response(tenSecondsAgo,
<a class="jxr_linenumber" name="272" href="#272">272</a>                 <span class="jxr_string">"public, max-age=5"</span>);
<a class="jxr_linenumber" name="273" href="#273">273</a> 
<a class="jxr_linenumber" name="274" href="#274">274</a>         backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="275" href="#275">275</a> 
<a class="jxr_linenumber" name="276" href="#276">276</a>         HttpRequest req2 = HttpTestUtils.makeDefaultRequest();
<a class="jxr_linenumber" name="277" href="#277">277</a>         req2.setHeader(<span class="jxr_string">"Cache-Control"</span>,<span class="jxr_string">"stale-if-error=2"</span>);
<a class="jxr_linenumber" name="278" href="#278">278</a>         HttpResponse resp2 = HttpTestUtils.make500Response();
<a class="jxr_linenumber" name="279" href="#279">279</a> 
<a class="jxr_linenumber" name="280" href="#280">280</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="281" href="#281">281</a> 
<a class="jxr_linenumber" name="282" href="#282">282</a>         replayMocks();
<a class="jxr_linenumber" name="283" href="#283">283</a>         impl.execute(host,req1);
<a class="jxr_linenumber" name="284" href="#284">284</a>         HttpResponse result = impl.execute(host,req2);
<a class="jxr_linenumber" name="285" href="#285">285</a>         verifyMocks();
<a class="jxr_linenumber" name="286" href="#286">286</a> 
<a class="jxr_linenumber" name="287" href="#287">287</a>         assertEquals(HttpStatus.SC_INTERNAL_SERVER_ERROR,
<a class="jxr_linenumber" name="288" href="#288">288</a>                 result.getStatusLine().getStatusCode());
<a class="jxr_linenumber" name="289" href="#289">289</a>     }
<a class="jxr_linenumber" name="290" href="#290">290</a> 
<a class="jxr_linenumber" name="291" href="#291">291</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="292" href="#292">292</a> <em class="jxr_comment">     * When present in an HTTP response, the stale-while-revalidate Cache-</em>
<a class="jxr_linenumber" name="293" href="#293">293</a> <em class="jxr_comment">     * Control extension indicates that caches MAY serve the response in</em>
<a class="jxr_linenumber" name="294" href="#294">294</a> <em class="jxr_comment">     * which it appears after it becomes stale, up to the indicated number</em>
<a class="jxr_linenumber" name="295" href="#295">295</a> <em class="jxr_comment">     * of seconds.</em>
<a class="jxr_linenumber" name="296" href="#296">296</a> <em class="jxr_comment">     *</em>
<a class="jxr_linenumber" name="297" href="#297">297</a> <em class="jxr_comment">     * <a href="http://tools.ietf.org/html/rfc5861" target="alexandria_uri">http://tools.ietf.org/html/rfc5861</a></em>
<a class="jxr_linenumber" name="298" href="#298">298</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="299" href="#299">299</a>     @Test
<a class="jxr_linenumber" name="300" href="#300">300</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleWhileRevalidateReturnsStaleEntryWithWarning()
<a class="jxr_linenumber" name="301" href="#301">301</a>         <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="302" href="#302">302</a> 
<a class="jxr_linenumber" name="303" href="#303">303</a>         params.setAsynchronousWorkersMax(1);
<a class="jxr_linenumber" name="304" href="#304">304</a>         impl = <strong class="jxr_keyword">new</strong> CachingHttpClient(mockBackend, cache, params);
<a class="jxr_linenumber" name="305" href="#305">305</a> 
<a class="jxr_linenumber" name="306" href="#306">306</a>         HttpRequest req1 = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>, HttpVersion.HTTP_1_1);
<a class="jxr_linenumber" name="307" href="#307">307</a>         HttpResponse resp1 = HttpTestUtils.make200Response();
<a class="jxr_linenumber" name="308" href="#308">308</a>         Date now = <strong class="jxr_keyword">new</strong> Date();
<a class="jxr_linenumber" name="309" href="#309">309</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(now.getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="310" href="#310">310</a>         resp1.setHeader(<span class="jxr_string">"Cache-Control"</span>, <span class="jxr_string">"public, max-age=5, stale-while-revalidate=15"</span>);
<a class="jxr_linenumber" name="311" href="#311">311</a>         resp1.setHeader(<span class="jxr_string">"ETag"</span>,<span class="jxr_string">"\&quot;etag\&quot;"</span>);
<a class="jxr_linenumber" name="312" href="#312">312</a>         resp1.setHeader(<span class="jxr_string">"Date"</span>, DateUtils.formatDate(tenSecondsAgo));
<a class="jxr_linenumber" name="313" href="#313">313</a> 
<a class="jxr_linenumber" name="314" href="#314">314</a>         backendExpectsAnyRequest().andReturn(resp1).times(1,2);
<a class="jxr_linenumber" name="315" href="#315">315</a> 
<a class="jxr_linenumber" name="316" href="#316">316</a>         HttpRequest req2 = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>, HttpVersion.HTTP_1_1);
<a class="jxr_linenumber" name="317" href="#317">317</a> 
<a class="jxr_linenumber" name="318" href="#318">318</a>         replayMocks();
<a class="jxr_linenumber" name="319" href="#319">319</a>         impl.execute(host, req1);
<a class="jxr_linenumber" name="320" href="#320">320</a>         HttpResponse result = impl.execute(host, req2);
<a class="jxr_linenumber" name="321" href="#321">321</a>         verifyMocks();
<a class="jxr_linenumber" name="322" href="#322">322</a> 
<a class="jxr_linenumber" name="323" href="#323">323</a>         assertEquals(HttpStatus.SC_OK, result.getStatusLine().getStatusCode());
<a class="jxr_linenumber" name="324" href="#324">324</a>         <strong class="jxr_keyword">boolean</strong> warning110Found = false;
<a class="jxr_linenumber" name="325" href="#325">325</a>         <strong class="jxr_keyword">for</strong>(Header h : result.getHeaders(<span class="jxr_string">"Warning"</span>)) {
<a class="jxr_linenumber" name="326" href="#326">326</a>             <strong class="jxr_keyword">for</strong>(WarningValue wv : WarningValue.getWarningValues(h)) {
<a class="jxr_linenumber" name="327" href="#327">327</a>                 <strong class="jxr_keyword">if</strong> (wv.getWarnCode() == 110) {
<a class="jxr_linenumber" name="328" href="#328">328</a>                     warning110Found = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="329" href="#329">329</a>                     <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="330" href="#330">330</a>                 }
<a class="jxr_linenumber" name="331" href="#331">331</a>             }
<a class="jxr_linenumber" name="332" href="#332">332</a>         }
<a class="jxr_linenumber" name="333" href="#333">333</a>         assertTrue(warning110Found);
<a class="jxr_linenumber" name="334" href="#334">334</a>     }
<a class="jxr_linenumber" name="335" href="#335">335</a> 
<a class="jxr_linenumber" name="336" href="#336">336</a>     @Test
<a class="jxr_linenumber" name="337" href="#337">337</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testCanAlsoServeStale304sWhileRevalidating()
<a class="jxr_linenumber" name="338" href="#338">338</a>         <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="339" href="#339">339</a> 
<a class="jxr_linenumber" name="340" href="#340">340</a>         params.setAsynchronousWorkersMax(1);
<a class="jxr_linenumber" name="341" href="#341">341</a>         params.setSharedCache(false);
<a class="jxr_linenumber" name="342" href="#342">342</a>         impl = <strong class="jxr_keyword">new</strong> CachingHttpClient(mockBackend, cache, params);
<a class="jxr_linenumber" name="343" href="#343">343</a> 
<a class="jxr_linenumber" name="344" href="#344">344</a>         HttpRequest req1 = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>, HttpVersion.HTTP_1_1);
<a class="jxr_linenumber" name="345" href="#345">345</a>         HttpResponse resp1 = HttpTestUtils.make200Response();
<a class="jxr_linenumber" name="346" href="#346">346</a>         Date now = <strong class="jxr_keyword">new</strong> Date();
<a class="jxr_linenumber" name="347" href="#347">347</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(now.getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="348" href="#348">348</a>         resp1.setHeader(<span class="jxr_string">"Cache-Control"</span>, <span class="jxr_string">"private, stale-while-revalidate=15"</span>);
<a class="jxr_linenumber" name="349" href="#349">349</a>         resp1.setHeader(<span class="jxr_string">"ETag"</span>,<span class="jxr_string">"\&quot;etag\&quot;"</span>);
<a class="jxr_linenumber" name="350" href="#350">350</a>         resp1.setHeader(<span class="jxr_string">"Date"</span>, DateUtils.formatDate(tenSecondsAgo));
<a class="jxr_linenumber" name="351" href="#351">351</a> 
<a class="jxr_linenumber" name="352" href="#352">352</a>         backendExpectsAnyRequest().andReturn(resp1).times(1,2);
<a class="jxr_linenumber" name="353" href="#353">353</a> 
<a class="jxr_linenumber" name="354" href="#354">354</a>         HttpRequest req2 = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>, HttpVersion.HTTP_1_1);
<a class="jxr_linenumber" name="355" href="#355">355</a>         req2.setHeader(<span class="jxr_string">"If-None-Match"</span>,<span class="jxr_string">"\&quot;etag\&quot;"</span>);
<a class="jxr_linenumber" name="356" href="#356">356</a> 
<a class="jxr_linenumber" name="357" href="#357">357</a>         replayMocks();
<a class="jxr_linenumber" name="358" href="#358">358</a>         impl.execute(host, req1);
<a class="jxr_linenumber" name="359" href="#359">359</a>         HttpResponse result = impl.execute(host, req2);
<a class="jxr_linenumber" name="360" href="#360">360</a>         verifyMocks();
<a class="jxr_linenumber" name="361" href="#361">361</a> 
<a class="jxr_linenumber" name="362" href="#362">362</a>         assertEquals(HttpStatus.SC_NOT_MODIFIED, result.getStatusLine().getStatusCode());
<a class="jxr_linenumber" name="363" href="#363">363</a>         <strong class="jxr_keyword">boolean</strong> warning110Found = false;
<a class="jxr_linenumber" name="364" href="#364">364</a>         <strong class="jxr_keyword">for</strong>(Header h : result.getHeaders(<span class="jxr_string">"Warning"</span>)) {
<a class="jxr_linenumber" name="365" href="#365">365</a>             <strong class="jxr_keyword">for</strong>(WarningValue wv : WarningValue.getWarningValues(h)) {
<a class="jxr_linenumber" name="366" href="#366">366</a>                 <strong class="jxr_keyword">if</strong> (wv.getWarnCode() == 110) {
<a class="jxr_linenumber" name="367" href="#367">367</a>                     warning110Found = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="368" href="#368">368</a>                     <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="369" href="#369">369</a>                 }
<a class="jxr_linenumber" name="370" href="#370">370</a>             }
<a class="jxr_linenumber" name="371" href="#371">371</a>         }
<a class="jxr_linenumber" name="372" href="#372">372</a>         assertTrue(warning110Found);
<a class="jxr_linenumber" name="373" href="#373">373</a>     }
<a class="jxr_linenumber" name="374" href="#374">374</a> 
<a class="jxr_linenumber" name="375" href="#375">375</a> 
<a class="jxr_linenumber" name="376" href="#376">376</a>     @Test
<a class="jxr_linenumber" name="377" href="#377">377</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleWhileRevalidateYieldsToMustRevalidate()
<a class="jxr_linenumber" name="378" href="#378">378</a>         <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="379" href="#379">379</a> 
<a class="jxr_linenumber" name="380" href="#380">380</a>         Date now = <strong class="jxr_keyword">new</strong> Date();
<a class="jxr_linenumber" name="381" href="#381">381</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(now.getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="382" href="#382">382</a> 
<a class="jxr_linenumber" name="383" href="#383">383</a>         params.setAsynchronousWorkersMax(1);
<a class="jxr_linenumber" name="384" href="#384">384</a>         impl = <strong class="jxr_keyword">new</strong> CachingHttpClient(mockBackend, cache, params);
<a class="jxr_linenumber" name="385" href="#385">385</a> 
<a class="jxr_linenumber" name="386" href="#386">386</a>         HttpRequest req1 = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>, HttpVersion.HTTP_1_1);
<a class="jxr_linenumber" name="387" href="#387">387</a>         HttpResponse resp1 = HttpTestUtils.make200Response();
<a class="jxr_linenumber" name="388" href="#388">388</a>         resp1.setHeader(<span class="jxr_string">"Cache-Control"</span>, <span class="jxr_string">"public, max-age=5, stale-while-revalidate=15, must-revalidate"</span>);
<a class="jxr_linenumber" name="389" href="#389">389</a>         resp1.setHeader(<span class="jxr_string">"ETag"</span>,<span class="jxr_string">"\&quot;etag\&quot;"</span>);
<a class="jxr_linenumber" name="390" href="#390">390</a>         resp1.setHeader(<span class="jxr_string">"Date"</span>, DateUtils.formatDate(tenSecondsAgo));
<a class="jxr_linenumber" name="391" href="#391">391</a> 
<a class="jxr_linenumber" name="392" href="#392">392</a>         backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="393" href="#393">393</a> 
<a class="jxr_linenumber" name="394" href="#394">394</a>         HttpRequest req2 = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>, HttpVersion.HTTP_1_1);
<a class="jxr_linenumber" name="395" href="#395">395</a>         HttpResponse resp2 = HttpTestUtils.make200Response();
<a class="jxr_linenumber" name="396" href="#396">396</a>         resp2.setHeader(<span class="jxr_string">"Cache-Control"</span>, <span class="jxr_string">"public, max-age=5, stale-while-revalidate=15, must-revalidate"</span>);
<a class="jxr_linenumber" name="397" href="#397">397</a>         resp2.setHeader(<span class="jxr_string">"ETag"</span>,<span class="jxr_string">"\&quot;etag\&quot;"</span>);
<a class="jxr_linenumber" name="398" href="#398">398</a>         resp2.setHeader(<span class="jxr_string">"Date"</span>, DateUtils.formatDate(now));
<a class="jxr_linenumber" name="399" href="#399">399</a> 
<a class="jxr_linenumber" name="400" href="#400">400</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="401" href="#401">401</a> 
<a class="jxr_linenumber" name="402" href="#402">402</a>         replayMocks();
<a class="jxr_linenumber" name="403" href="#403">403</a>         impl.execute(host, req1);
<a class="jxr_linenumber" name="404" href="#404">404</a>         HttpResponse result = impl.execute(host, req2);
<a class="jxr_linenumber" name="405" href="#405">405</a>         verifyMocks();
<a class="jxr_linenumber" name="406" href="#406">406</a> 
<a class="jxr_linenumber" name="407" href="#407">407</a>         assertEquals(HttpStatus.SC_OK, result.getStatusLine().getStatusCode());
<a class="jxr_linenumber" name="408" href="#408">408</a>         <strong class="jxr_keyword">boolean</strong> warning110Found = false;
<a class="jxr_linenumber" name="409" href="#409">409</a>         <strong class="jxr_keyword">for</strong>(Header h : result.getHeaders(<span class="jxr_string">"Warning"</span>)) {
<a class="jxr_linenumber" name="410" href="#410">410</a>             <strong class="jxr_keyword">for</strong>(WarningValue wv : WarningValue.getWarningValues(h)) {
<a class="jxr_linenumber" name="411" href="#411">411</a>                 <strong class="jxr_keyword">if</strong> (wv.getWarnCode() == 110) {
<a class="jxr_linenumber" name="412" href="#412">412</a>                     warning110Found = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="413" href="#413">413</a>                     <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="414" href="#414">414</a>                 }
<a class="jxr_linenumber" name="415" href="#415">415</a>             }
<a class="jxr_linenumber" name="416" href="#416">416</a>         }
<a class="jxr_linenumber" name="417" href="#417">417</a>         assertFalse(warning110Found);
<a class="jxr_linenumber" name="418" href="#418">418</a>     }
<a class="jxr_linenumber" name="419" href="#419">419</a> 
<a class="jxr_linenumber" name="420" href="#420">420</a>     @Test
<a class="jxr_linenumber" name="421" href="#421">421</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleWhileRevalidateYieldsToProxyRevalidateForSharedCache()
<a class="jxr_linenumber" name="422" href="#422">422</a>         <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="423" href="#423">423</a> 
<a class="jxr_linenumber" name="424" href="#424">424</a>         Date now = <strong class="jxr_keyword">new</strong> Date();
<a class="jxr_linenumber" name="425" href="#425">425</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(now.getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="426" href="#426">426</a> 
<a class="jxr_linenumber" name="427" href="#427">427</a>         params.setAsynchronousWorkersMax(1);
<a class="jxr_linenumber" name="428" href="#428">428</a>         params.setSharedCache(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="429" href="#429">429</a>         impl = <strong class="jxr_keyword">new</strong> CachingHttpClient(mockBackend, cache, params);
<a class="jxr_linenumber" name="430" href="#430">430</a> 
<a class="jxr_linenumber" name="431" href="#431">431</a>         HttpRequest req1 = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>, HttpVersion.HTTP_1_1);
<a class="jxr_linenumber" name="432" href="#432">432</a>         HttpResponse resp1 = HttpTestUtils.make200Response();
<a class="jxr_linenumber" name="433" href="#433">433</a>         resp1.setHeader(<span class="jxr_string">"Cache-Control"</span>, <span class="jxr_string">"public, max-age=5, stale-while-revalidate=15, proxy-revalidate"</span>);
<a class="jxr_linenumber" name="434" href="#434">434</a>         resp1.setHeader(<span class="jxr_string">"ETag"</span>,<span class="jxr_string">"\&quot;etag\&quot;"</span>);
<a class="jxr_linenumber" name="435" href="#435">435</a>         resp1.setHeader(<span class="jxr_string">"Date"</span>, DateUtils.formatDate(tenSecondsAgo));
<a class="jxr_linenumber" name="436" href="#436">436</a> 
<a class="jxr_linenumber" name="437" href="#437">437</a>         backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="438" href="#438">438</a> 
<a class="jxr_linenumber" name="439" href="#439">439</a>         HttpRequest req2 = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>, HttpVersion.HTTP_1_1);
<a class="jxr_linenumber" name="440" href="#440">440</a>         HttpResponse resp2 = HttpTestUtils.make200Response();
<a class="jxr_linenumber" name="441" href="#441">441</a>         resp2.setHeader(<span class="jxr_string">"Cache-Control"</span>, <span class="jxr_string">"public, max-age=5, stale-while-revalidate=15, proxy-revalidate"</span>);
<a class="jxr_linenumber" name="442" href="#442">442</a>         resp2.setHeader(<span class="jxr_string">"ETag"</span>,<span class="jxr_string">"\&quot;etag\&quot;"</span>);
<a class="jxr_linenumber" name="443" href="#443">443</a>         resp2.setHeader(<span class="jxr_string">"Date"</span>, DateUtils.formatDate(now));
<a class="jxr_linenumber" name="444" href="#444">444</a> 
<a class="jxr_linenumber" name="445" href="#445">445</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="446" href="#446">446</a> 
<a class="jxr_linenumber" name="447" href="#447">447</a>         replayMocks();
<a class="jxr_linenumber" name="448" href="#448">448</a>         impl.execute(host, req1);
<a class="jxr_linenumber" name="449" href="#449">449</a>         HttpResponse result = impl.execute(host, req2);
<a class="jxr_linenumber" name="450" href="#450">450</a>         verifyMocks();
<a class="jxr_linenumber" name="451" href="#451">451</a> 
<a class="jxr_linenumber" name="452" href="#452">452</a>         assertEquals(HttpStatus.SC_OK, result.getStatusLine().getStatusCode());
<a class="jxr_linenumber" name="453" href="#453">453</a>         <strong class="jxr_keyword">boolean</strong> warning110Found = false;
<a class="jxr_linenumber" name="454" href="#454">454</a>         <strong class="jxr_keyword">for</strong>(Header h : result.getHeaders(<span class="jxr_string">"Warning"</span>)) {
<a class="jxr_linenumber" name="455" href="#455">455</a>             <strong class="jxr_keyword">for</strong>(WarningValue wv : WarningValue.getWarningValues(h)) {
<a class="jxr_linenumber" name="456" href="#456">456</a>                 <strong class="jxr_keyword">if</strong> (wv.getWarnCode() == 110) {
<a class="jxr_linenumber" name="457" href="#457">457</a>                     warning110Found = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="458" href="#458">458</a>                     <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="459" href="#459">459</a>                 }
<a class="jxr_linenumber" name="460" href="#460">460</a>             }
<a class="jxr_linenumber" name="461" href="#461">461</a>         }
<a class="jxr_linenumber" name="462" href="#462">462</a>         assertFalse(warning110Found);
<a class="jxr_linenumber" name="463" href="#463">463</a>     }
<a class="jxr_linenumber" name="464" href="#464">464</a> 
<a class="jxr_linenumber" name="465" href="#465">465</a>     @Test
<a class="jxr_linenumber" name="466" href="#466">466</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testStaleWhileRevalidateYieldsToExplicitFreshnessRequest()
<a class="jxr_linenumber" name="467" href="#467">467</a>         <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="468" href="#468">468</a> 
<a class="jxr_linenumber" name="469" href="#469">469</a>         Date now = <strong class="jxr_keyword">new</strong> Date();
<a class="jxr_linenumber" name="470" href="#470">470</a>         Date tenSecondsAgo = <strong class="jxr_keyword">new</strong> Date(now.getTime() - 10 * 1000L);
<a class="jxr_linenumber" name="471" href="#471">471</a> 
<a class="jxr_linenumber" name="472" href="#472">472</a>         params.setAsynchronousWorkersMax(1);
<a class="jxr_linenumber" name="473" href="#473">473</a>         params.setSharedCache(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="474" href="#474">474</a>         impl = <strong class="jxr_keyword">new</strong> CachingHttpClient(mockBackend, cache, params);
<a class="jxr_linenumber" name="475" href="#475">475</a> 
<a class="jxr_linenumber" name="476" href="#476">476</a>         HttpRequest req1 = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>, HttpVersion.HTTP_1_1);
<a class="jxr_linenumber" name="477" href="#477">477</a>         HttpResponse resp1 = HttpTestUtils.make200Response();
<a class="jxr_linenumber" name="478" href="#478">478</a>         resp1.setHeader(<span class="jxr_string">"Cache-Control"</span>, <span class="jxr_string">"public, max-age=5, stale-while-revalidate=15"</span>);
<a class="jxr_linenumber" name="479" href="#479">479</a>         resp1.setHeader(<span class="jxr_string">"ETag"</span>,<span class="jxr_string">"\&quot;etag\&quot;"</span>);
<a class="jxr_linenumber" name="480" href="#480">480</a>         resp1.setHeader(<span class="jxr_string">"Date"</span>, DateUtils.formatDate(tenSecondsAgo));
<a class="jxr_linenumber" name="481" href="#481">481</a> 
<a class="jxr_linenumber" name="482" href="#482">482</a>         backendExpectsAnyRequest().andReturn(resp1);
<a class="jxr_linenumber" name="483" href="#483">483</a> 
<a class="jxr_linenumber" name="484" href="#484">484</a>         HttpRequest req2 = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>, HttpVersion.HTTP_1_1);
<a class="jxr_linenumber" name="485" href="#485">485</a>         req2.setHeader(<span class="jxr_string">"Cache-Control"</span>,<span class="jxr_string">"min-fresh=2"</span>);
<a class="jxr_linenumber" name="486" href="#486">486</a>         HttpResponse resp2 = HttpTestUtils.make200Response();
<a class="jxr_linenumber" name="487" href="#487">487</a>         resp2.setHeader(<span class="jxr_string">"Cache-Control"</span>, <span class="jxr_string">"public, max-age=5, stale-while-revalidate=15"</span>);
<a class="jxr_linenumber" name="488" href="#488">488</a>         resp2.setHeader(<span class="jxr_string">"ETag"</span>,<span class="jxr_string">"\&quot;etag\&quot;"</span>);
<a class="jxr_linenumber" name="489" href="#489">489</a>         resp2.setHeader(<span class="jxr_string">"Date"</span>, DateUtils.formatDate(now));
<a class="jxr_linenumber" name="490" href="#490">490</a> 
<a class="jxr_linenumber" name="491" href="#491">491</a>         backendExpectsAnyRequest().andReturn(resp2);
<a class="jxr_linenumber" name="492" href="#492">492</a> 
<a class="jxr_linenumber" name="493" href="#493">493</a>         replayMocks();
<a class="jxr_linenumber" name="494" href="#494">494</a>         impl.execute(host, req1);
<a class="jxr_linenumber" name="495" href="#495">495</a>         HttpResponse result = impl.execute(host, req2);
<a class="jxr_linenumber" name="496" href="#496">496</a>         verifyMocks();
<a class="jxr_linenumber" name="497" href="#497">497</a> 
<a class="jxr_linenumber" name="498" href="#498">498</a>         assertEquals(HttpStatus.SC_OK, result.getStatusLine().getStatusCode());
<a class="jxr_linenumber" name="499" href="#499">499</a>         <strong class="jxr_keyword">boolean</strong> warning110Found = false;
<a class="jxr_linenumber" name="500" href="#500">500</a>         <strong class="jxr_keyword">for</strong>(Header h : result.getHeaders(<span class="jxr_string">"Warning"</span>)) {
<a class="jxr_linenumber" name="501" href="#501">501</a>             <strong class="jxr_keyword">for</strong>(WarningValue wv : WarningValue.getWarningValues(h)) {
<a class="jxr_linenumber" name="502" href="#502">502</a>                 <strong class="jxr_keyword">if</strong> (wv.getWarnCode() == 110) {
<a class="jxr_linenumber" name="503" href="#503">503</a>                     warning110Found = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="504" href="#504">504</a>                     <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="505" href="#505">505</a>                 }
<a class="jxr_linenumber" name="506" href="#506">506</a>             }
<a class="jxr_linenumber" name="507" href="#507">507</a>         }
<a class="jxr_linenumber" name="508" href="#508">508</a>         assertFalse(warning110Found);
<a class="jxr_linenumber" name="509" href="#509">509</a>     }
<a class="jxr_linenumber" name="510" href="#510">510</a> 
<a class="jxr_linenumber" name="511" href="#511">511</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

